SystemOrganization addCategory: #'Polymorph-ToolBuilder-Morphic'!
SystemOrganization addCategory: #'Polymorph-ToolBuilder-Kernel'!

PluggablePanelMorph subclass: #PluggableThemedPanelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Morphic'!

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 15:12'!
adoptPaneColor: aColor
	"Set the pane color."
	
	super adoptPaneColor: aColor.
	aColor ifNil: [^self].
	self fillStyle: self normalFillStyle! !

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 15:30'!
color: aColor
	"Set the pane color."
	
	(self valueOfProperty: #fillStyle ifAbsent: []) ifNil: [
		super color: aColor]! !

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 4/24/2007 12:13'!
extent: aPoint
	"Update the bar fillStyle if appropriate."
	
	super extent: aPoint.
	self fillStyle isOrientedFill ifTrue: [
		self fillStyle: self normalFillStyle]! !

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 15:09'!
initialize
	"Initialize the receiver."

	super initialize.
	self
		layoutInset: 2;
		cellInset: 4! !

!PluggableThemedPanelMorph methodsFor: 'as yet unclassified' stamp: 'gvc 5/23/2007 14:29'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	UITheme ifNil: [^self paneColor].
	^self theme buttonPanelNormalFillStyleFor: self! !

MorphicUIManager subclass: #PSUIManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Morphic'!

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 14:21'!
chooseColor
	"Answer the user choice of a colour."
	
	^self
		chooseColor: Color black
		title: nil! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 14:21'!
chooseColor: aColor
	"Answer the user choice of a colour."
	
	^self
		chooseColor: aColor
		title: nil! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 14:20'!
chooseColor: aColor title: label
	"Answer the user choice of a colour."
	
	^UITheme current
		chooseColorIn: self modalMorph
		title: (label ifNil: ['Choose Color' translated])
		color: aColor! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 12:38'!
chooseDirectory: label from: dir
	"Answer the user choice of a directory."
	
	^UITheme current
		chooseDirectoryIn: self modalMorph
		title: (label ifNil: ['Choose Directory' translated])
		path: (dir ifNotNil: [dir pathName])! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 10/4/2007 13:29'!
chooseFileMatching: patterns label: label
	"Let the user choose a file matching the given patterns"
	
	^UITheme current
		chooseFileNameIn: self modalMorph
		title: (label ifNil: ['Choose File' translated])
		extensions: patterns
		path: nil
		preview: false! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 14:01'!
chooseFont
	"Answer the user choice of a font."
	
	^self chooseFont: nil! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 14:01'!
chooseFont: aFontOrNil
	"Answer the user choice of a font."
	
	^self
		chooseFont: aFontOrNil
		title: nil! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 10/9/2007 14:00'!
chooseFont: aFontOrNil title: label
	"Answer the user choice of a font."
	
	^UITheme current
		chooseFontIn: self modalMorph
		title: (label ifNil: ['Choose Font' translated])
		font: aFontOrNil! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2009 13:00'!
chooseFrom: aList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^(self
		chooseFrom: aList
		values: nil
		lines: linesArray
		message: messageString
		title: aString) ifNil: [0]! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 1/15/2007 16:34'!
chooseFrom: aList lines: linesArray title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^(self
		chooseFrom: aList
		values: nil
		lines: linesArray
		title: aString) ifNil: [0]! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 2/6/2009 12:36'!
chooseFrom: labelList values: valueList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^UITheme current
		chooseIn: self modalMorph
		title: aString
		message: messageString
		labels: labelList
		values: valueList
		lines: linesArray! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 1/16/2007 12:38'!
chooseFrom: labelList values: valueList lines: linesArray title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^UITheme current
		chooseIn: self modalMorph
		title: aString
		labels: labelList
		values: valueList
		lines: linesArray! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 3/30/2009 16:46'!
confirm: aStringOrText
	"Put up a question dialog (without cancel) with the text queryString.
	Answer true if the response is yes, false if no.
	This is a modal question--the user must respond yes or no."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNilDo: [:answer |
		^answer].
	^UITheme current 
		questionWithoutCancelIn: self modalMorph
		text: aStringOrText
		title: 'Question' translated! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 3/30/2009 16:46'!
confirm: aStringOrText orCancel: cancelBlock
	"Put up a question dialog (with cancel) with the text queryString.
	Answer true if the response is yes, false if no.
	Answer the value of the cancel block if cancelled.
	This is a modal question--the user must respond yes or no or cancel."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNilDo: [:answer |
		^answer == #cancel ifTrue: [cancelBlock value] ifFalse: [answer]].
	^(UITheme current
		questionIn: self modalMorph
		text: aStringOrText
		title: 'Question' translated) ifNil: cancelBlock! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 3/30/2009 16:47'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice 
	"Put up a yes/no menu with caption queryString. The actual wording for the two choices will be as provided in the trueChoice and falseChoice parameters. Answer true if the response is the true-choice, false if it's the false-choice.
	This is a modal question -- the user must respond one way or the other."
	
	(ProvideAnswerNotification signal: queryString) ifNotNilDo: [:answer |
		^answer].
	^UITheme current 
		customQuestionIn: self modalMorph
		text: queryString
		yesText: trueChoice
		noText: falseChoice
		title: 'Question' translated! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 3/30/2009 16:44'!
inform: aStringOrText
	"Display a message for the user to read and then dismiss."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNilDo: [:answer |
		^true].
	^UITheme current
		messageIn: self modalMorph
		text: aStringOrText
		title: 'Information' translated! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 5/12/2009 13:01'!
informUserDuring: aBlock
	"Display a message as progress	during execution of the given block."
	"UIManager default informUserDuring: [:bar|
		#('one' 'two' 'three') do: [:info|
			bar value: info.
			1 to: 100 do: [:v |
				bar value: v.
				(Delay forMilliseconds: 20) wait]]]"
	
	self
		displayProgress: ''
		at: Sensor cursorPoint
		from: 1 to: 100
		during: [:bar | aBlock value: bar]! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 12/2/2008 16:35'!
modalMorph
	"Answer the morph that should be used to handle modality."
	
	|sender receiver foundWorld|
	sender := thisContext sender.
	foundWorld := false.
	[foundWorld or: [sender isNil]] whileFalse: [
		receiver := sender receiver.
		((receiver isKindOf: TheWorldMainDockingBar) or: [
			((receiver isKindOf: TheWorldMenu) or: [sender selector = #putUpWorldMenu:]) or: [
				receiver == World and: [sender selector == #handleEvent: or: [sender selector == #findWindow:]]]])
			ifTrue: [	foundWorld := true]
			ifFalse: [sender := sender sender]].
	foundWorld ifTrue: [^receiver world ifNil: [World]].
	^SystemWindow topWindow ifNil: [World]! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 9/11/2009 11:57'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight
	"Create a multi-line instance of me whose question is queryString with
	the given initial answer. Invoke it centered at the given point, and
	answer the string the user accepts.  Answer nil if the user cancels.  An
	empty string returned means that the ussr cleared the editing area and
	then hit 'accept'.  Because multiple lines are invited, we ask that the user
	use the ENTER key, or (in morphic anyway) hit the 'accept' button, to 
	submit; that way, the return key can be typed to move to the next line."
	
	|response|
	(ProvideAnswerNotification signal: queryString) ifNotNilDo: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	response := UITheme current
		textEditorIn: self modalMorph
		text: queryString
		title: 'Information Required' translated
		entryText: defaultAnswer
		entryHeight: answerHeight.
	^response ifNotNil: [response asString]! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 9/11/2009 11:50'!
request: aStringOrText initialAnswer: defaultAnswer 
	"Create an instance of me whose question is queryString with the given 
	initial answer. Answer the string the user accepts.
	Answer nil if the user cancels.
	Allow for interception with a ProvideAnswerNotification handler."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNilDo: [:answer |
		^answer == #default ifTrue: [defaultAnswer] ifFalse: [answer]].
	^UITheme current
		textEntryIn: self modalMorph
		text: aStringOrText
		title: 'Information Required' translated
		entryText: defaultAnswer! !

!PSUIManager methodsFor: 'as yet unclassified' stamp: 'gvc 9/11/2009 11:50'!
requestPassword: aStringOrText 
	"Request for a password.
	Allow for interception with a ProvideAnswerNotification handler.
	Answer nil if the user cancels."
	
	(ProvideAnswerNotification signal: aStringOrText) ifNotNilDo: [:answer |
		^answer == #default ifTrue: [''] ifFalse: [answer]].
	^UITheme current 
		passwordEntryIn: self modalMorph
		text: aStringOrText
		title: 'Password Required' translated
		entryText: ''! !

StandardWindow subclass: #PluggableStandardWindow
	instanceVariableNames: 'getLabelSelector getChildrenSelector children closeWindowSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Morphic'!

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
addPaneMorph: aMorph
	self addMorph: aMorph fullFrame: aMorph layoutFrame! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
closeWindowSelector
	^closeWindowSelector! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
closeWindowSelector: aSymbol
	closeWindowSelector := aSymbol! !

!PluggableStandardWindow methodsFor: 'initialization' stamp: 'gvc 7/30/2009 13:41'!
delete
	"Should be this way around since the window may not close
	for other reasons!!"
	
	|m|
	m := model.
	super delete.
	closeWindowSelector ifNotNil:[m perform: closeWindowSelector]! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
getLabelSelector
	^getLabelSelector! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol.
	self update: aSymbol.! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
label
	^label contents! !

!PluggableStandardWindow methodsFor: 'accessing' stamp: 'gvc 1/9/2007 13:31'!
label: aString
	self setLabel: aString.! !

!PluggableStandardWindow methodsFor: 'updating' stamp: 'gvc 1/9/2007 13:31'!
update: what
	what ifNil:[^self].
	what == getLabelSelector ifTrue:[self setLabel: (model perform: getLabelSelector)].
	what == getChildrenSelector ifTrue:[
		children ifNil:[children := #()].
		self removeAllMorphsIn: children.
		children := model perform: getChildrenSelector.
		self addAllMorphs: children.
		children do:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].
	^super update: what! !

MorphicToolBuilder subclass: #PSToolBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Morphic'!

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2007 18:09'!
buildPluggableList: aSpec
	"Build an appropriate pluggable list."
	
	| widget |
	aSpec icon
		ifNil: [widget := super buildPluggableList: aSpec]
		ifNotNil: [widget := PluggableIconListMorph new
					getIconSelector: aSpec icon;
					on: aSpec model
					list: aSpec list
					selected: aSpec getIndex
					changeSelected: aSpec setIndex
					menu: aSpec menu
					keystroke: aSpec keyPress.
				self register: widget id: aSpec name.
				widget autoDeselect: aSpec autoDeselect.
				self setFrame: aSpec frame in: widget.
				parent ifNotNil:[self add: widget to: parent].
				panes ifNotNil:[aSpec list ifNotNil:[panes add: aSpec list]]].
	widget doubleClickSelector: aSpec action.
	^widget! !

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'gvc 3/14/2007 15:31'!
buildPluggablePanel: aSpec
	"Build a pluggable panel (aka button row!!)."
	
	| widget children |
	widget := PluggableThemedPanelMorph new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	widget fillStyle: widget normalFillStyle.
	widget clipSubmorphs: true.
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #().
	].
	self buildAll: children in: widget.
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	self setLayout: aSpec layout in: widget.
	^widget! !

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'gvc 1/9/2007 13:34'!
buildPluggableWindow: aSpec
	| widget children label |
	aSpec layout == #proportional ifFalse:[
		"This needs to be implemented - probably by adding a single pane and then the rest"
		^self error: 'Not implemented'.
	].
	widget := PluggableStandardWindow new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	(label := aSpec label) ifNotNil:[
		label isSymbol 
			ifTrue:[widget getLabelSelector: label]
			ifFalse:[widget setLabel: label]].
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #().
	].
	widget closeWindowSelector: aSpec closeAction.
	panes := OrderedCollection new.
	self buildAll: children in: widget.
	aSpec extent ifNotNil:[widget extent: aSpec extent].
	widget setUpdatablePanesFrom: panes.
	^widget! !

!PSToolBuilder methodsFor: 'as yet unclassified' stamp: 'gvc 1/8/2007 17:39'!
pluggableListSpec
	"Answer the spec supporting an action selector (doubleclick)."
	
	^PSPluggableListSpec! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:45'!
chooseFrom: aList lines: linesArray message: messageString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList lines: linesArray message: messageString title: ''! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:47'!
chooseFrom: aList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^self
		chooseFrom: aList
		lines: linesArray
		title: (aString 
				ifEmpty: [messageString]
				ifNotEmpty: [aString, String cr, messageString])! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:45'!
chooseFrom: aList message: messageString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList lines: #() message: messageString! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:44'!
chooseFrom: aList message: messageString title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList lines: #() message: messageString title: aString! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:50'!
chooseFrom: aList values: valueList lines: linesArray message: messageString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList values: valueList lines: linesArray message: messageString title: ''! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:52'!
chooseFrom: labelList values: valueList lines: linesArray message: messageString title: aString
	"Choose an item from the given list. Answer the selected item."
	
	^self
		chooseFrom: labelList
		values: valueList 
		lines: linesArray
		title: (aString 
				ifEmpty: [messageString]
				ifNotEmpty: [aString, String cr, messageString])! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:49'!
chooseFrom: aList values: valueList message: messageString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList values: valueList lines: #() message: messageString! !

!UIManager methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 2/6/2009 12:50'!
chooseFrom: aList values: valueList message: messageString title: aString
	"Choose an item from the given list. Answer the index of the selected item."
	
	^self chooseFrom: aList values: valueList lines: #() message: messageString title: aString! !

PluggableListSpec subclass: #PSPluggableListSpec
	instanceVariableNames: 'icon action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Polymorph-ToolBuilder-Kernel'!

!PSPluggableListSpec methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:19'!
action
	"Answer the value of action"

	^ action! !

!PSPluggableListSpec methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:19'!
action: anObject
	"Set the value of action"

	action := anObject! !

!PSPluggableListSpec methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:19'!
icon
	"Answer the value of icon"

	^ icon! !

!PSPluggableListSpec methodsFor: 'accessing' stamp: 'gvc 1/8/2007 17:19'!
icon: anObject
	"Set the value of icon"

	icon := anObject! !

!TheWorldMenu methodsFor: '*Polymorph-ToolBuilder' stamp: 'gvc 1/24/2007 16:42'!
world
	"Answer myWorld."

	^myWorld! !
